;|	JUSTWIPE v.1.0.							;;
	Copyright DuctiSOFT inc.		2010-06-22		;;
									;;
	Create all Wipeout needed					;;
									;;
	S:								;;
	sellect any entity even CIRCLE ARC ELLIPSE and/or SPLINE	;;
	it don't matter if the object is CLOSE or NOT			;;
	also, JustWipe allow to select multiple entities in 1 selection!;;
									;;
	M or F:								;;
	Freehands option mean that you can draw Freehand Wipeout	;;
	(similar to SKETCH command) incrementation distance is		;;
	depending the VIEWSIZE variable					;;
									;;
	P:								;;
	Draw Polygonal geometry figure wipeout				;;
									|;

(princ "\nJustWIPE v.1.0. by DuctiSOFT inc......*** loaded !
To start, use \"JUSTWIPE\" or \"JW\" command."
       )



(vl-load-com)
;;	JUSTWIPE LANGUAGE			;;
						;;
(defun justwipe_language ()

(setq JWmess0 ">: ")
  
(if (vl-string-search "(fr)" (ver))
  (progn    
    (setq JWmess1 "\n(S)lection d'objet / (M)ain leve / (P)olygonale ? <")
    (setq JWmess2 "\Mode \"Main Leve\" dbut...")
    (setq JWmess3 "\nMode \"Polygonale\" dbut...")
    (setq JWmess4 "\nSlectionnez vos entitis...")
  )
  (progn    
    (setq JWmess1 "\nobject (S)election / (F)ree hands / (P)olygonal ? <")
    (setq JWmess2 "\nMode \"Free hands\" start...")
    (setq JWmess3 "\nMode \"Polygonal\" start...")
    (setq JWmess4 "\nEntities Selection...")
  )
    
)
)
						;;
;;	JUSTWIPE LANGUAGE			;;





;;	JUSTWIPE COMMAND			;;
						;;
(defun c:JW ()(c:justwipe))
(defun c:JustWipe (/ selmode JWmess0 JWmess1 JWmess2 JWmess3 JWmess4)
(justwipe_language)  
(vla-StartUndoMark (vla-get-ActiveDocument (vlax-get-ACAD-Object)))
  (if (and smo
           (member smo '("S" "F" "M" "P")))
    (princ)
    (setq smo "P")
  )
  
  (initget "S M F P")
  (setq selMode (getkword (strcat JWmess1 smo JWmess0)))
  (if selmode (setq smo selmode))
  
  (if smo
    (progn      
      (if (eq smo "S")(justwipe_S))
      (if (member smo '("M" "F"))(justwipe_F))
      (if (eq smo "P")(justwipe_P))
    )
  )
(vla-EndUndoMark (vla-get-ActiveDocument (vlax-get-ACAD-Object)))
)
						;;
;;	JUSTWIPE COMMAND			;;






;;	JUSTWIPE POLYGON			;;
						;;
(defun justwipe_P (/ fpoint drawl input npoint lastenti lastentget)

(setvar "CMDECHO" 0)  

(setq fpoint (getpoint JWmess3))
(setq drawl fpoint)
(command "._Pline" fpoint)
(while  (and (setq input (grread t 4 4))
                (or
                  (= (car input) 5)
                  (= (car input) 3)
                )
                )

(if (= (car input) 5)
  (progn
  (redraw)
  (grdraw drawl (cadr input) 1 0)
  
    (grdraw fpoint (cadr input) 1 0)
  
  )
)
  
  (if (= (car input) 3)
    (progn
      (setq npoint (cadr input))
      (command npoint)
      (setq drawl npoint)
    )
  )
)
  
(if (/= (getvar "cmdactive") 0)
  (command "_C")
)
(command)
(redraw)

(setq lastenti (entlast))

(if (and (setq lastentget (entget lastenti))
         (member (cdr (assoc 0 lastentget)) '("LWPOLYLINE" "POLYLINE"))
         (eq (vla-get-Closed (vlax-ename->vla-object lastenti)) :vlax-true)
    )
(progn
      (vl-cmdf "._wipeout" "_P" lastenti "_N")     
      (vl-cmdf "._draworder" (entlast) "" "_U" lastenti "")
      (vl-cmdf "._erase" lastenti "")
      )
 )
  
  (princ)
)
						;;
;;	JUSTWIPE POLYGON			;;






;;	JUSTWIPE FREEHANDS			;;
						;;
(defun justwipe_F (/ FHinc_i fpoint drawl input npoint lastenti lastentget)

(setvar "CMDECHO" 0)  
(setq FHinc_i (/ (getvar "viewsize") 133.0))  
(setq fpoint (getpoint JWmess2))
  (command "._Pline" fpoint)
(while (or (and (setq input (grread t 4 4)) (= (car input) 5)))
  (if (and (= (car input) 5)
           (> (distance fpoint (setq npoint (cadr input))) fhinc_i)
      )
    (progn (command npoint) (redraw) (grdraw fpoint npoint 1 0))
  )
)
  
(if (/= (getvar "cmdactive") 0)
  (command "_C")
)
(command)
(redraw)


(setq lastenti (entlast))

(if (and (setq lastentget (entget lastenti))
         (member (cdr (assoc 0 lastentget)) '("LWPOLYLINE" "POLYLINE"))
         (eq (vla-get-Closed (vlax-ename->vla-object lastenti)) :vlax-true)
    )
(progn
      (vl-cmdf "._wipeout" "_P" lastenti "_N")     
      (vl-cmdf "._draworder" (entlast) "" "_U" lastenti "")
      (vl-cmdf "._erase" lastenti "")
      )
 )

  (princ)
  
)
						;;
;;	JUSTWIPE FREEHANDS			;;






;;	JUSTWIPE SELECTION			;;
						;;
(defun justwipe_S (/ ssentities ssent_Length item cquoi vla_item filterobject_C val)
  
(setq filterobject_C '("POLYLINE" "LWPOLYLINE" "CIRCLE" "ELLIPSE" "ARC" "SPLINE"))  

(princ JWmess4)  
(setq ssentities (ssget))
  
(setq ssent_Length (sslength ssentities))
(setq val ssent_Length)
(setq items (ssadd))
  
(repeat ssent_Length
  (setq item (ssname ssentities (setq val (1- val))))
  (setq cquoi (cdr (assoc 0 (entget item))))
  (setq vla_item (vlax-ename->vla-object item))

  (if (member cquoi filterobject_C)
    (progn
      (go&wipe vla_item cquoi item)      
    )
  )

)
)
						;;
;;	JUSTWIPE SELECTION			;;






;;	JUSTWIPE WIPEOUT CREATION		;;
						;;
(defun go&wipe (vlai ckoi ite / itex const sp dist allpoints newpoint)
  (setvar "CMDECHO" 0)
  (if (member ckoi '("POLYLINE" "LWPOLYLINE"))
    (progn
      (if (eq :vlax-true (vla-get-closed vlai))
        (progn (vl-cmdf "._wipeout" "_P" ite "_N")
               (vl-cmdf "._draworder" (entlast) "" "_U" ite "")
        )
        (progn (vl-cmdf "._copy" ite "" "0,0" "0,0")
               (setq itex (entlast))
               (vl-cmdf "._pedit" itex "_C" "")
               (setq itex (entlast))
               (vl-cmdf "._wipeout" "_P" itex "_N")
               (vl-cmdf "._draworder" (entlast) "" "_U" ite "")
               (vl-cmdf "._erase" itex "")
        )
      )
    )
  )
  (if (member ckoi '("CIRCLE" "ELLIPSE" "ARC" "SPLINE"))
    (progn (setq const (/ (vlax-curve-getdistatparam
                            vlai
                            (vlax-curve-getendparam vlai)
                          )
                          50.0
                       )
           )
           (setq sp (vlax-curve-getstartpoint vlai))
           (setq dist const)
           (setq allpoints nil
                 newpoint nil
           )
           (repeat 49
             (setq newpoint (vlax-curve-getpointatdist vlai (setq dist (+ const dist))))
             (setq allpoints (append allpoints (list newpoint)))
           )
           (if allpoints
             (progn (setq allpoints (append (list sp) allpoints))
                    (command "_.pline")
                    (mapcar 'command allpoints)
                    (command "_C")
             )
           )
           (setq itex (entlast))
           (vl-cmdf "._wipeout" "_P" itex "_N")
           (vl-cmdf "._draworder" (entlast) "" "_U" ite "")
           (vl-cmdf "._erase" itex "")
    )
  )
  (princ)
)
						;;
;;	JUSTWIPE WIPEOUT CREATION		;;

